
/*
---------------------------------------------------------------------------
ECN FreeSoft
---------------------------------------------------------------------------
Progetto : music32
Modulo   : device.cpp
Inizio   : 29.07.2000
Fine     :
Versione : 1.0
Autore/i : Giorgio D.Plescan
Commento :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Include
---------------------------------------------------------------------------
*/

# include       <stdio.h>
# include       <math.h>
# include       <stdlib.h>
# include       <string.h>
# include       <io.h>
# include       <conio.h>
# include	<errno.h>

# include	"music32.h"
# include	"device.h"

/*
---------------------------------------------------------------------------
Variabili globali
---------------------------------------------------------------------------
*/
		
/*
---------------------------------------------------------------------------
Funzioni menbro
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Segnale
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Segnale::Segnale
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Segnale::Segnale (void)
{

	Valore = 0;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::Segnale
Input    : double
Output   :
Commento :
---------------------------------------------------------------------------
*/

Segnale::Segnale (double val)
{

	Valore = val;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::LeggiValore
Input    : void
Output   : double
Commento :
---------------------------------------------------------------------------
*/

inline double Segnale::LeggiValore (void)
{

	return Valore;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::ScriviValore
Input    : double
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Segnale::ScriviValore (double val)
{

	Valore = val;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator+
Input    : Segnale
Output   : Segnale
Commento :
---------------------------------------------------------------------------
*/

inline Segnale Segnale::operator+(Segnale val)
{

	Segnale
		tmp;
	
	tmp.Valore = this->Valore + val.Valore;
	return tmp;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator-
Input    : void
Output   : Segnale
Commento :
---------------------------------------------------------------------------
*/

inline Segnale Segnale::operator-(void)
{

	Segnale
		tmp;
	
	tmp.Valore = -this->Valore;
	return tmp;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator-
Input    : Segnale
Output   : Segnale
Commento :
---------------------------------------------------------------------------
*/

inline Segnale Segnale::operator-(Segnale val)
{

	Segnale
		tmp;
	
	tmp.Valore = this->Valore - val.Valore;
	return tmp;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator*
Input    : Segnale
Output   : Segnale
Commento :
---------------------------------------------------------------------------
*/

inline Segnale Segnale::operator*(Segnale val)
{

	Segnale
		tmp;
	
	tmp.Valore = this->Valore * val.Valore;
	return tmp;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator/
Input    : Segnale
Output   : Segnale
Commento :
---------------------------------------------------------------------------
*/

inline Segnale Segnale::operator/(Segnale val)
{

	Segnale
		tmp;
	
	tmp.Valore = this->Valore / val.Valore;
	return tmp;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator=
Input    : Segnale
Output   : Segnale
Commento :
---------------------------------------------------------------------------
*/

inline Segnale Segnale::operator=(Segnale val)
{

	this->Valore = val.Valore;
	return *this;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator==
Input    : Segnale
Output   : int
Commento :
---------------------------------------------------------------------------
*/

inline int Segnale::operator==(Segnale val)
{

	if (this->Valore == val.Valore)
		return 1;
	else
		return 0;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator!=
Input    : Segnale
Output   : int
Commento :
---------------------------------------------------------------------------
*/

inline int Segnale::operator!=(Segnale val)
{

	if (this->Valore != val.Valore)
		return 1;
	else
		return 0;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator<
Input    : Segnale
Output   : int
Commento :
---------------------------------------------------------------------------
*/

inline int Segnale::operator<(Segnale val)
{

	if (this->Valore < val.Valore)
		return 1;
	else
		return 0;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator>
Input    : Segnale
Output   : int
Commento :
---------------------------------------------------------------------------
*/

inline int Segnale::operator>(Segnale val)
{

	if (this->Valore > val.Valore)
		return 1;
	else
		return 0;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator<=
Input    : Segnale
Output   : int
Commento :
---------------------------------------------------------------------------
*/

inline int Segnale::operator<=(Segnale val)
{

	if (this->Valore <= val.Valore)
		return 1;
	else
		return 0;

}

/*
---------------------------------------------------------------------------
Funzione : Segnale::operator>=
Input    : Segnale
Output   : int
Commento :
---------------------------------------------------------------------------
*/

inline int Segnale::operator>=(Segnale val)
{

	if (this->Valore >= val.Valore)
		return 1;
	else
		return 0;

}

/*
---------------------------------------------------------------------------
Formaonda
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Formaonda::Formaonda
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Formaonda::Formaonda (void)
{
	
	Init();

}

/*
---------------------------------------------------------------------------
Funzione : Formaonda::Init
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Formaonda::Init (void)
{

	static char
		* procname = "Formaonda::Init";
	register
		i;
	double
		valsin = 0.0,
		valtrg = -1.0,
		valrmp = -1.0,
		valtan = -(PI_GRECO * 0.45),
		inctan = ((PI_GRECO * 0.90) / (double)N_PUNTI), 
		inctrg;

	sprintf(Applicazione::ErrMsg, "%s : START ... ", procname);
	Applicazione::Log(Applicazione::ErrMsg);

	inc_reali    = (double)N_PUNTI / PUNTI_VIRTUALI;
	inc_sin      = (_2PI_GRECO / (double)N_PUNTI);
	inc_rmp      = (2.0 / (double)N_PUNTI);
	inc_trg      = (2.0 / (double)N_PUNTI_2);

	for (i = 0; i < N_PUNTI; i++)
	{

		Campione[  SENO][i] = sin(valsin);
		Campione[TRIANG][i] = valtrg;
		Campione[QUADRA][i] = (i < N_PUNTI_2)? -1.0: 1.0;
		Campione[ RAMPA][i] = valrmp;
		Campione[ PARAB][i] = (2 * valrmp * valrmp) - 1.0;
		Campione[  TANG][i] = tan(valtan) / 6.3;

		valsin += inc_sin;
		valrmp += inc_rmp;

		inctrg = (i < N_PUNTI_2)? inc_trg: -inc_trg;
		valtrg += inctrg;

		valtan += inctan;

	}

	Applicazione::Log("OK\n");

}

/*
---------------------------------------------------------------------------
Funzione : Formaonda::LeggiCampione
Input    : int
         : double
Output   : double
Commento :
---------------------------------------------------------------------------
*/

inline double Formaonda::LeggiCampione (int on, double idx)
{

	static char
		* procname = "Formaonda::LeggiCampione";
	DWORD
		i;
	double
		t,
		f,
		r,
		val1,
		val2;

	t = idx * inc_reali;
	f = floor(t);
	r = t - f;

	i = (DWORD)f;

	//sprintf(Applicazione::ErrMsg, "%s : IDX=%1u I=%1u\n", procname, idx, i);
	//Applicazione::Log(Applicazione::ErrMsg);

	val1 = Campione [on][i % N_PUNTI],
	val2 = Campione [on][(i + 1) % N_PUNTI];

	if (val1 < val2)
		return val1 + (fabs(val1 - val2) * r);
	else
		return val1 - (fabs(val1 - val2) * r);

}

/*
---------------------------------------------------------------------------
Dispositivo
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::Init
Input    : int
         : int
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Dispositivo::Init (int ing, int usc)
{

	static char
		* procname = "Dispositivo::Init";
	int
		i;

	n_Ingressi = 1;
	n_Uscite   = 1;

	if ((ing > 0) && (ing < 1024))
		n_Ingressi = ing;
	 
	if ((usc > 0) && (usc < 1024))
		n_Uscite = usc;

	if ((p_Ingresso = (Dispositivo **)calloc(n_Ingressi, sizeof(Dispositivo *))) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : Errore allocazione memoria\n", procname);
		Applicazione::Log(Applicazione::ErrMsg);

	}

	if ((Ingresso = (Segnale **)calloc(n_Ingressi, sizeof(Segnale *))) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : Errore allocazione memoria\n", procname);
		Applicazione::Log(Applicazione::ErrMsg);

	}

	if ((Uscita = (Segnale **)calloc(n_Uscite, sizeof(Segnale *))) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : Errore allocazione memoria\n", procname);
		Applicazione::Log(Applicazione::ErrMsg);

	}

	if ((IndiceUscite = (int *)calloc(n_Ingressi, sizeof(int))) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : Errore allocazione memoria\n", procname);
		Applicazione::Log(Applicazione::ErrMsg);

	}

	for (i = 0; i < n_Ingressi; i++)
	{

		p_Ingresso  [i] = NULL;
		IndiceUscite[i] = -1;
		Ingresso    [i] = new Segnale(0.0);

	}

	for (i = 0; i < n_Uscite; i++)
	{

		Uscita[i] = new Segnale(0.0);

	}

	Chiamata = 0;
	Nome[0]  = 0;

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::Dispositivo
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Dispositivo::Dispositivo (void)
{

	Init(1, 1);

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::Dispositivo
Input    : int
         : int
Output   :
Commento :
---------------------------------------------------------------------------
*/

Dispositivo::Dispositivo (int ing, int usc)
{
	 
	Init(ing, usc);

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::Debug
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Dispositivo::Debug (void)
{

	int
		i;

	Custom();

	for (i = 0; i < n_Ingressi; i++)
	{

		sprintf(Applicazione::ErrMsg, "\tIngresso %3d : Attivo=%1d Valore=%9.3lf\n", i, IngressoAttivo(i), Ingresso[i]->LeggiValore());
		Applicazione::Log(Applicazione::ErrMsg);

	}

	for (i = 0; i < n_Uscite; i++)
	{

		sprintf(Applicazione::ErrMsg, "\tUscita   %3d :          Valore=%9.3lf\n", i, Uscita[i]->LeggiValore());
		Applicazione::Log(Applicazione::ErrMsg);

	}

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::LeggiNome
Input    : char *
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Dispositivo::LeggiNome (char * str)
{

	if (str != NULL)
		strcpy(str, Nome);

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::ScriviNome
Input    : char *
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Dispositivo::ScriviNome (char * str)
{

	if ((str != NULL) && (str[0] != 0))
		strcpy(Nome, str);

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::LeggiUscita
Input    : int
Output   : Segnale
Commento :
---------------------------------------------------------------------------
*/

inline Segnale Dispositivo::LeggiUscita (int canale)
{

	//canale = (canale < 0)? 0: canale;
	//canale %= n_Uscite;

	return *(Uscita[canale]);

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::ScriviUscita
Input    : Segnale
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Dispositivo::ScriviUscita (int canale, Segnale val)
{

	//canale = (canale < 0)? 0: canale;
	//canale %= n_Uscite;

	*(Uscita[canale]) = val;

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::LeggiChiamata
Input    : void
Output   : DWORD
Commento :
---------------------------------------------------------------------------
*/

inline DWORD Dispositivo::LeggiChiamata (void)
{

	return Chiamata;

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::ScriviChiamata
Input    : DWORD
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Dispositivo::ScriviChiamata (DWORD chiamata)
{

	Chiamata = chiamata;

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::LeggiIngresso
Input    : int
Output   : Segnale
Commento :
---------------------------------------------------------------------------
*/

inline Segnale Dispositivo::LeggiIngresso (int canale)
{

	//canale = (canale < 0)? 0: canale;
	//canale %= n_Ingressi;

	return *(Ingresso[canale]);

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::ScriviIngresso
Input    : int
         : Segnale
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Dispositivo::ScriviIngresso (int canale, Segnale val)
{

	//canale = (canale < 0)? 0: canale;
	//canale %= n_Ingressi;
	
	*(Ingresso[canale]) = val;

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::CollegaIngresso
Input    : int
         : Dispositivo *
Output   : int
Commento :
---------------------------------------------------------------------------
*/

void Dispositivo::CollegaIngresso (int canale_src, int canale_dst, Dispositivo * indirizzo)
{

	if ((indirizzo != NULL) && (canale_src >= 0) && (canale_src < indirizzo->n_Uscite) && (canale_dst >= 0) && (canale_dst < n_Ingressi))
	{

		p_Ingresso  [canale_dst] = indirizzo;
		IndiceUscite[canale_dst] = canale_src;

	}

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::StaccaIngresso
Input    : int
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Dispositivo::StaccaIngresso (int canale)
{

	if ((canale >= 0) && (canale < n_Ingressi))
	{
	
		p_Ingresso  [canale] = NULL;
		IndiceUscite[canale] = -1;

	}

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::NumeroIngressi
Input    : void
Output   : int
Commento :
---------------------------------------------------------------------------
*/

int Dispositivo::NumeroIngressi (void)
{

	return n_Ingressi;

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::NumeroUscite
Input    : void
Output   : int
Commento :
---------------------------------------------------------------------------
*/

int Dispositivo::NumeroUscite (void)
{

	return n_Uscite;

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::IngressoAttivo
Input    : int
Output   : int
Commento :
---------------------------------------------------------------------------
*/

int Dispositivo::IngressoAttivo (int canale)
{

	//canale = (canale < 0)? 0: canale;
	//canale %= n_Ingressi;

	if (p_Ingresso[canale] != NULL)
		return 1;
	else
		return 0;

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::Esporta
Input    : void
Output   : Dispositivo *
Commento :
---------------------------------------------------------------------------
*/

Dispositivo * Dispositivo::Esporta (void)
{

	return this;

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::AggiornaIngresso
Input    : int
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Dispositivo::AggiornaIngresso (int canale)
{

	//canale = (canale < 0)? 0: canale;
	//canale %= n_Ingressi;

	if (p_Ingresso[canale] != NULL)
	{

		p_Ingresso[canale]->Elabora(Chiamata);
		*(Ingresso [canale]) = p_Ingresso[canale]->LeggiUscita(IndiceUscite[canale]);

	}

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::Elabora
Input    : DWORD
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Dispositivo::Elabora (DWORD chiamata)
{

	if (chiamata <= Chiamata)
		return;

	Chiamata = chiamata;

	for (int i = 0; i < n_Ingressi; i++)
		AggiornaIngresso(i);

	Calcola();

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Dispositivo::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Dispositivo::Custom\n");
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Dispositivo::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Dispositivo::Calcola (void)
{

	sprintf(Applicazione::ErrMsg, "Dispositivo::Calcola\n");
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Dispositivo : Registratore
Ingressi    : 0 - Segnale pista 0
            : 1 - Segnale pista 1
Uscita      :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Registratore::Registratore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Registratore::Registratore (void)
{

	strcpy(NomeFile, "music32m.raw");
	Piste = 1;
	Init(Piste, 1);
	Apri();

}

/*
---------------------------------------------------------------------------
Funzione : Registratore::Registratore
Input    : char *
         : int
Output   :
Commento :
---------------------------------------------------------------------------
*/

Registratore::Registratore (char * nomef, int piste)
{

	strcpy(NomeFile, nomef);
	Piste = (piste > 0)? piste % 1024: 1;
	Init(Piste, 1);
	Apri();

}

/*
---------------------------------------------------------------------------
Funzione : Registratore::Apri
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Registratore::Apri (void)
{

	static char
		* procname = "Registratore::Apri";

	if ((Fp = fopen(NomeFile, "wb")) != NULL)
		return;

	sprintf(Applicazione::ErrMsg, "%s : fopen(%s) - error %1d\n", procname, NomeFile, errno);
	Applicazione::Error(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Registratore::Scrivi
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Registratore::Scrivi (void)
{

	short
		intval;
	double
		fpval;
	BYTE
		* pval;

	for (int i = 0; i < Piste; i++)
	{

		fpval  = Ingresso[i]->LeggiValore();
		//intval = (short)(fpval * 1.0);
		intval = (short)(fpval);
		pval   = (BYTE *)&intval;

		if (Fp != NULL)
			fprintf(Fp, "%c%c", pval[0], pval[1]);

	}

}

/*
---------------------------------------------------------------------------
Funzione : Registratore::Chiudi
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Registratore::Chiudi (void)
{

	fclose(Fp);

}

/*
---------------------------------------------------------------------------
Funzione : Registratore::ChiudiTutto
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Registratore::ChiudiTutto (void)
{

	_fcloseall();

}

/*
---------------------------------------------------------------------------
Funzione : Registratore::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Registratore::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Registratore %s - File=%s Piste=%1d\n", Nome, NomeFile, Piste);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Registratore::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Registratore::Calcola (void)
{

	Scrivi();

}

/*
---------------------------------------------------------------------------
Dispositivo : Conduttore
Ingressi    : 0 - Segnale 
Uscita      :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Conduttore::Conduttore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Conduttore::Conduttore (void)
{

	Init(1, 1);

}

/*
---------------------------------------------------------------------------
Funzione : Conduttore::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Conduttore::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Conduttore %s\n", Nome);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Conduttore::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Conduttore::Calcola (void)
{

	*Uscita[0] = *Ingresso[0];

}

/*
---------------------------------------------------------------------------
Dispositivo : Invertitore 
Ingressi    : 0 - Segnale
Uscita      :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Invertitore::Invertitore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Invertitore::Invertitore (void)
{

	Init(1, 1);

}

/*
---------------------------------------------------------------------------
Funzione : Invertitore::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Invertitore::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Invertitore %s\n", Nome);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Invertitore::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Invertitore::Calcola (void)
{

	*Uscita[0] = (-(*Ingresso[0]));

}

/*
---------------------------------------------------------------------------
Dispositivo : Assoluto 
Ingressi    : 0 - Segnale 
Uscita      :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Assoluto::Assoluto
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Assoluto::Assoluto (void)
{

	Init(1, 1);

}

/*
---------------------------------------------------------------------------
Funzione : Assoluto::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Assoluto::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Assoluto %s\n", Nome);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Assoluto::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Assoluto::Calcola (void)
{

	Uscita[0]->ScriviValore(fabs(Ingresso[0]->LeggiValore()));

}

/*
---------------------------------------------------------------------------
Dispositivo : Memoria 
Ingressi    : 0 - Segnale 
Uscita      :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Memoria::Memoria
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Memoria::Memoria (void)
{

	Init(1, 1);
	Mem.ScriviValore(0.0);

}

/*
---------------------------------------------------------------------------
Funzione : Memoria::Memoria
Input    : Segnale
Output   :
Commento :
---------------------------------------------------------------------------
*/

Memoria::Memoria (Segnale val)
{

	Init(1, 1);
	Mem            = val;
	*(Ingresso[0]) = val;

}

/*
---------------------------------------------------------------------------
Funzione : Memoria::LeggiMemoria
Input    : void
Output   : Segnale
Commento :
---------------------------------------------------------------------------
*/

inline Segnale Memoria::LeggiMemoria (void)
{

	return Mem;

}

/*
---------------------------------------------------------------------------
Funzione : Memoria::ScriviMemoria
Input    : Segnale
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Memoria::ScriviMemoria (Segnale val)
{

	Mem = val;

}

/*
---------------------------------------------------------------------------
Funzione : Memoria::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Memoria::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Memoria %s - Mem=%9.3lf\n", Nome, Mem.LeggiValore());
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Memoria::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Memoria::Calcola (void)
{

	*(Uscita[0]) = Mem;
	Mem          = *(Ingresso[0]);

}

/*
---------------------------------------------------------------------------
Dispositivo : Rumore
Ingressi    :
Uscita      :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Rumore::Rumore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Rumore::Rumore (void)
{

	Init(0, 1);
	inc_rnd = (2.0 / (double)RAND_MAX);

}

/*
---------------------------------------------------------------------------
Funzione : Rumore::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Rumore::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Rumore %s\n", Nome);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Rumore::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Rumore::Calcola (void)
{

	Segnale
		tmp(((double)rand() * inc_rnd) - 1.0);

	*(Uscita[0]) = tmp;

}

/*
---------------------------------------------------------------------------
Dispositivo : Sommatore
Ingressi    : 
Uscita      :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Sommatore::Sommatore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Sommatore::Sommatore (void)
{

	Init(2, 1);

}

/*
---------------------------------------------------------------------------
Funzione : Sommatore::Sommatore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Sommatore::Sommatore (int nin)
{

	Init(nin, 1);

}

/*
---------------------------------------------------------------------------
Funzione : Sommatore::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Sommatore::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Sommatore %s\n", Nome);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Sommatore::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Sommatore::Calcola (void)
{

	Segnale
		tmp(0.0);

	for (int i = 0; i < n_Ingressi; i++)
		tmp = tmp + *(Ingresso[i]);

	*(Uscita[0]) = tmp;

}

/*
---------------------------------------------------------------------------
Dispositivo : Moltiplicatore
Ingressi    : 
Uscita      :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Moltiplicatore::Moltiplicatore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Moltiplicatore::Moltiplicatore (void)
{

	Init(2, 1);

	for (int i = 0; i < n_Ingressi; i++)
		Ingresso[i]->ScriviValore(1.0);

}

/*
---------------------------------------------------------------------------
Funzione : Moltiplicatore::Moltiplicatore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Moltiplicatore::Moltiplicatore (int nin)
{

	Init(nin, 1);

	for (int i = 0; i < n_Ingressi; i++)
		Ingresso[i]->ScriviValore(1.0);

}

/*
---------------------------------------------------------------------------
Funzione : Moltiplicatore::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Moltiplicatore::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Moltiplicatore %s\n", Nome);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Moltiplicatore::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Moltiplicatore::Calcola (void)
{

	Segnale
		tmp(1.0);

	for (int i = 0; i < n_Ingressi; i++)
		tmp = tmp * *(Ingresso[i]);

	*(Uscita[0]) = tmp;

}

/*
---------------------------------------------------------------------------
Dispositivo : Modulatore
Ingressi    : 0 - Segnale
            : 1 - Amplificazione
	    : 2 - Offset
Uscita      :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Modulatore::Modulatore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Modulatore::Modulatore (void)
{

	Init(3, 1);
	Ingresso[0]->ScriviValore(0.0);
	Ingresso[1]->ScriviValore(1.0);
	Ingresso[2]->ScriviValore(0.0);

}

/*
---------------------------------------------------------------------------
Funzione : Modulatore::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Modulatore::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Modulatore %s\n", Nome);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Modulatore::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Modulatore::Calcola (void)
{

	*(Uscita[0]) = (*(Ingresso[0]) * *(Ingresso[1])) + *(Ingresso[2]);

}

/*
---------------------------------------------------------------------------
Dispositivo : Compressore
Ingressi    : 0 - Segnale
            : 1 - Soglia 
Uscita      :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Compressore::Compressore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Compressore::Compressore (void)
{

	Init(2, 1);
	Soglia.ScriviValore(0.0);

}

/*
---------------------------------------------------------------------------
Funzione : Compressore::Compressore
Input    : double
Output   :
Commento :
---------------------------------------------------------------------------
*/

Compressore::Compressore (double val)
{

	Init(2, 1);
	Soglia.ScriviValore(val);
	*(Ingresso[1]) = Soglia;

}

/*
---------------------------------------------------------------------------
Funzione : Compressore::LeggiSoglia
Input    : void
Output   : double
Commento :
---------------------------------------------------------------------------
*/

inline double Compressore::LeggiSoglia (void)
{

	return Soglia.LeggiValore();

}

/*
---------------------------------------------------------------------------
Funzione : Compressore::ScriviSoglia
Input    : double
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Compressore::ScriviSoglia (double val)
{

	Soglia.ScriviValore(val);
	*(Ingresso[1]) = Soglia;

}

/*
---------------------------------------------------------------------------
Funzione : Compressore::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Compressore::Custom (void)
{

	sprintf(Applicazione::ErrMsg, "Compressore %s - Soglia=%9.3lf\n", Nome, Soglia.LeggiValore());
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Compressore::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Compressore::Calcola (void)
{

	Soglia          = *(Ingresso[1]);
	double soglia   = Soglia.LeggiValore();
	double ingresso = Ingresso[0]->LeggiValore();
	double uscita;

	if (soglia == 0.0)  // Soglia = 0 : ritorno 0
	{

		uscita = 0.0;

	}
	else if (soglia > 0.0)  // Soglia > 0 : ritorno segnale se abs(segnale) < soglia
	{

		if (ingresso > soglia)
			uscita = soglia;
		else if (ingresso < -soglia)
			uscita = -soglia;
		else
			uscita = ingresso;

	}
	else  // Soglia < 0 : ritorno segnale se abs(soglia) < segnale
	{

		if (ingresso < soglia)
			uscita = ingresso;
		else if (ingresso > -soglia)
			uscita = ingresso;
		else
			uscita = soglia;

	}

	Uscita[0]->ScriviValore(uscita);

}

/*
---------------------------------------------------------------------------
Dispositivo : Oscillatore
Ingressi    : 0 - Frequenza 0 .. F_CAMPION_2
            : 1 - Fase      -_2PI_GRECO .. _2PI_GRECO
	    : 2 - Modulazione Frequenza  0 .. 
	    : 3 - Modulazione Simmetria -1 .. 1
	    : 4 - Ripartenza 0,1
Uscita      : 0 - Segnale
            : 1 - -Segnale
---------------------------------------------------------------------------
*/

Formaonda * Oscillatore::Tabella = NULL;

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::Oscillatore
Input    : int
         : double
Output   :
Commento :
---------------------------------------------------------------------------
*/

Oscillatore::Oscillatore (int onda, double freq)
{

	Init(5, 2);

	if (Tabella == NULL)
		Tabella = new Formaonda;

	Cont  = 0.0;
	inc_virtuali = PUNTI_VIRTUALI / F_CAMPION;
	inc_fase     = PUNTI_VIRTUALI / _2PI_GRECO;

	ScriviOnda(onda);
	ScriviFrequenza(freq, 1.0);
	ScriviFase(0.0);
	ScriviDuty(0.5);

	Ingresso[0]->ScriviValore(Freq);
	Ingresso[1]->ScriviValore(Fase);
	Ingresso[2]->ScriviValore(1.0);
	Ingresso[3]->ScriviValore(Duty);
	Ingresso[4]->ScriviValore(0.0);

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::Oscillatore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Oscillatore::Oscillatore (void)
{

	Init(5, 2);

	if (Tabella == NULL)
		Tabella = new Formaonda;

	Cont         = 0.0;
	inc_virtuali = PUNTI_VIRTUALI / F_CAMPION;
	inc_fase     = PUNTI_VIRTUALI / _2PI_GRECO;

	ScriviOnda(SENO);
	ScriviFrequenza(1000.0, 1.0);
	ScriviFase(0.0);
	ScriviDuty(0.5);

	Ingresso[0]->ScriviValore(Freq);
	Ingresso[1]->ScriviValore(Fase);
	Ingresso[2]->ScriviValore(1.0);
	Ingresso[3]->ScriviValore(Duty);
	Ingresso[4]->ScriviValore(0.0);

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::ScriviCont
Input    : double
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Oscillatore::ScriviCont (double cont)
{

	Cont = cont;

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::LeggiCont
Input    : void
Output   : double
Commento :
---------------------------------------------------------------------------
*/

inline double Oscillatore::LeggiCont (void)
{

	return Cont;

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::LeggiOnda
Input    : void
Output   : int
Commento :
---------------------------------------------------------------------------
*/

inline int Oscillatore::LeggiOnda (void)
{

	return Onda;

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::LeggiFrequenza
Input    : void
Output   : double
Commento :
---------------------------------------------------------------------------
*/

inline double Oscillatore::LeggiFrequenza (void)
{

	return Freq;

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::LeggiDuty
Input    : void
Output   : double
Commento :
---------------------------------------------------------------------------
*/

inline double Oscillatore::LeggiDuty (void)
{

	return Duty;

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::LeggiFase
Input    : void
Output   : double
Commento :
---------------------------------------------------------------------------
*/

inline double Oscillatore::LeggiFase (void)
{

	return Fase;

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::ScriviOnda
Input    : int
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Oscillatore::ScriviOnda (int onda)
{

	Onda = abs(onda) % N_ONDE;

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::ScriviFrequenza
Input    : double
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Oscillatore::ScriviFrequenza (double freq, double mfreq)
{

	double
		tmp;

	tmp  = freq * mfreq;
	Freq = (tmp < 0.0)? 0.0: ((tmp > F_CAMPION_2)? 0.0: tmp);

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::ScriviFase
Input    : double
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Oscillatore::ScriviFase (double fase)
{

	Fase = (fase < 0.0)? fmod(-fase, _2PI_GRECO): fmod(fase, _2PI_GRECO);

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::ScriviDuty
Input    : double
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Oscillatore::ScriviDuty (double duty)
{

	Duty = (duty < 0.0)? 0.0: ((duty > 1.0)? 1.0: duty);

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::Custom
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Oscillatore::Custom (void)
{


	sprintf(Applicazione::ErrMsg, "Oscillatore %s - Onda=%1d Freq=%9.3lf Duty=%9.3lf Fase=%9.3lf\n", Nome, Onda, Freq, Duty, Fase);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Oscillatore::Calcola
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

inline void Oscillatore::Calcola (void)
{

	static char
		* procname = "Oscillatore::Calcola";
	double
		idx,
		idx_duty,
		cont_fase,
		cont,
		value;

	ScriviFrequenza(Ingresso[0]->LeggiValore(), Ingresso[2]->LeggiValore());
	ScriviFase(Ingresso[1]->LeggiValore());
	ScriviDuty(Ingresso[3]->LeggiValore());

	if (Ingresso[4]->LeggiValore() >= 1.0)
	{

		Cont  = 0.0;

	}

	cont_fase = (Fase * inc_fase);
	idx_duty  = (Duty * PUNTI_VIRTUALI);
	idx_duty  = (idx_duty < 1.0)? 1.0: ((idx_duty == PUNTI_VIRTUALI)? PUNTI_VIRTUALI - 1: idx_duty);

	cont  = Cont + cont_fase;
	cont  = (cont < PUNTI_VIRTUALI)? cont: cont - PUNTI_VIRTUALI;  

	if (cont < idx_duty)
		idx = (cont / idx_duty) * PUNTI_VIRTUALI_2;
	else if (cont > idx_duty)
		idx = PUNTI_VIRTUALI_2 + (((cont - idx_duty) / (PUNTI_VIRTUALI - idx_duty)) * PUNTI_VIRTUALI_2);
	else
		idx = PUNTI_VIRTUALI_2;

	value  = Tabella->LeggiCampione(Onda, idx);

	Uscita[0]->ScriviValore(value);
	Uscita[1]->ScriviValore(-value);

	Cont += (Freq * inc_virtuali);
	Cont  = (Cont < PUNTI_VIRTUALI)? Cont: Cont - PUNTI_VIRTUALI;  

	//sprintf(Applicazione::ErrMsg, "%s : CONT=%1u\n", procname, Cont);
	//Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Sintetizzatore
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Funzione : Sintetizzatore::Sintetizzatore
Input    : void
Output   :
Commento :
---------------------------------------------------------------------------
*/

Sintetizzatore::Sintetizzatore (void)
{

	static char
		* procname = "Sintetizzatore::Sintetizzatore";

	Quanti = 0;

	sprintf(Applicazione::ErrMsg, "%s :\n", procname);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Sintetizzatore::Sintetizzatore
Input    : int
Output   :
Commento :
---------------------------------------------------------------------------
*/

Sintetizzatore::Sintetizzatore (int ndevice)
{

	static char
		* procname = "Sintetizzatore::Sintetizzatore";

	Quanti = 0;

	sprintf(Applicazione::ErrMsg, "%s : NDEVICE=%1d\n", procname, ndevice);
	Applicazione::Log(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Sintetizzatore::CollegaOggetti
Input    : int
         : int
	 : int
Output   : void
Commento :
---------------------------------------------------------------------------
*/

int Sintetizzatore::CollegaOggetti (int src, int cs, int dest, int cd)
{

	static char
		* procname = "Sintetizzatore::CollegaOggetti";

	sprintf(Applicazione::ErrMsg, "%s : SRC=%1d CNL=%1d DEST=%1d CNL=%1d\n", procname, src, cs, dest, cd);
	Applicazione::Log(Applicazione::ErrMsg);

	if ((cs < 0) || (cs >= Lista[src]->NumeroUscite()) || (cd < 0) || (cd >= Lista[dest]->NumeroIngressi()))
		return APP_ERROR;

	Lista[dest]->CollegaIngresso(cs, cd, (Dispositivo *)Lista[src]->Esporta());
	return APP_OK;

}

/*
---------------------------------------------------------------------------
Funzione : Sintetizzatore::CancellaOggetti
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Sintetizzatore::CancellaOggetti (void)
{

	static char
		* procname = "Sintetizzatore::CancellaOggetti";

	Registratore::ChiudiTutto();

	sprintf(Applicazione::ErrMsg, "%s : \n", procname);
	Applicazione::Log(Applicazione::ErrMsg);

 	for (int i = 0; i < Quanti; i++)
		delete Lista[i];

}

/*
---------------------------------------------------------------------------
Funzione : Sintetizzatore::InserisciOggetti
Input    : Dispositivo *
Output   : char *
Commento :
---------------------------------------------------------------------------
*/

void Sintetizzatore::InserisciOggetti (Dispositivo * dev, char * nome)
{

	static char
		* procname = "Sintetizzatore::InserisciOggetti";

	sprintf(Applicazione::ErrMsg, "%s : NOME=|%s|\n", procname, nome);
	Applicazione::Log(Applicazione::ErrMsg);

	Lista[Quanti] = dev;
	Lista[Quanti]->ScriviNome(nome);
	Quanti++;

}

/*
---------------------------------------------------------------------------
Funzione : Sintetizzatore::CercaOggetti
Input    : char *
Output   : int
Commento :
---------------------------------------------------------------------------
*/

int Sintetizzatore::CercaOggetti (char * nome)
{

	static char
		* procname = "Sintetizzatore::CercaOggetti";
	char
		devname [DEV_NAME_LEN + 1];
	int
		idx = NULL_INDEX,
		i;

	sprintf(Applicazione::ErrMsg, "%s : NOME=|%s|\n", procname, nome);
	Applicazione::Log(Applicazione::ErrMsg);

	for (i = 0; i < Quanti; i++)
	{

		Lista[i]->LeggiNome(devname);

		if (strcmp(devname, nome) == 0)
		{

			idx = i;
			break;

		}

	}

	return idx;

}

/*
---------------------------------------------------------------------------
Funzione : Sintetizzatore::IngressoOggetti
Input    : double
         : int
	 : int
Output   : int
Commento :
---------------------------------------------------------------------------
*/

int Sintetizzatore::IngressoOggetti (double value, int dest, int cnl)
{

	static char
		* procname = "Sintetizzatore::IngressoOggetti";
	Segnale
		tmp;

	sprintf(Applicazione::ErrMsg, "%s : VALUE=%lf DEST=%1d CNL=%1d\n", procname, value, dest, cnl);
	Applicazione::Log(Applicazione::ErrMsg);

	if ((cnl < 0) || (cnl >= Lista[dest]->NumeroIngressi()))
		return APP_ERROR;

	tmp.ScriviValore(value);
	Lista[dest]->ScriviIngresso(cnl, tmp);
	return APP_OK;

}

/*
---------------------------------------------------------------------------
Funzione : Sintetizzatore::DebugOggetti
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Sintetizzatore::DebugOggetti (void)
{

	static char
		* procname = "Sintetizzatore::DebugOggetti";
	int
		i;

	sprintf(Applicazione::ErrMsg, "Sintetizzatore : Quanti=%3d  Contatore=%9lu\n", Quanti, Contatore);
	Applicazione::Log(Applicazione::ErrMsg);

	for (i = 0; i < Quanti; i++)
		Lista[i]->Debug();

}

/*
---------------------------------------------------------------------------
Funzione : Sintetizzatore::ElaboraOggetti
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Sintetizzatore::ElaboraOggetti (void)
{

	static char
		* procname = "Sintetizzatore::ElaboraOggetti";
	int
		i;
	DWORD
		scatto = (DWORD)(F_CAMPION / 10.0);

	Contatore = 0;
	DebugOggetti();

	for (;;)
	{

		for (i = 0; i < Quanti; i++)
			Lista[i]->Elabora(Contatore);

		if ((++Contatore % scatto) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : %9lu campioni - %9.3lf secondi\n",
				procname, Contatore, (double)Contatore / F_CAMPION);
			Applicazione::Debug(Applicazione::ErrMsg);

		}

		if (Applicazione::User())
				break;

	}

	CancellaOggetti();

	sprintf(Applicazione::ErrMsg, "%s : %9lu campioni - %9.3lf secondi\n",
		procname, Contatore, (double)Contatore / F_CAMPION);
	Applicazione::Log(Applicazione::ErrMsg);

}

