
/*
---------------------------------------------------------------------------
ECN FreeSoft
---------------------------------------------------------------------------
Progetto : music32
Modulo   : music32.cpp
Inizio   : 29.07.2000
Fine     :
Versione : 1.0
Autore/i : Giorgio D.Plescan
Commento :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Switch
---------------------------------------------------------------------------
*/

//# define      DEBUG

/*
---------------------------------------------------------------------------
Include
---------------------------------------------------------------------------
*/

# include       <stdio.h>
# include       <math.h>
# include       <stdlib.h>
# include       <string.h>
# include       <io.h>
# include       <conio.h>
# include	<errno.h>

# include	"music32.h"
# include	"device.h"
# include	"parser.h"

/*
---------------------------------------------------------------------------
Funzioni locali
---------------------------------------------------------------------------
*/

int  main (int ac, char ** av);

/*
---------------------------------------------------------------------------
Variabili globali
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Applicazione
---------------------------------------------------------------------------
*/

char
	* Applicazione::Logo     = "*** Music32 - by GioDim ***",
	* Applicazione::Versione = "*** ver 1.0 - (08.2000) ***",
	Applicazione::ErrMsg [200];

/*
---------------------------------------------------------------------------
Funzione : Applicazione::Debug
Input    : char *
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Applicazione::Debug (char * msg)
{

	fprintf(stderr, "%s", msg);

}

/*
---------------------------------------------------------------------------
Funzione : Applicazione::Log
Input    : char *
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Applicazione::Log (char * msg)
{

	static char
		* logname = "music32.log";
	static FILE
		* fp;

	Debug(msg);

	if ((fp = fopen(logname, "a")) != NULL)
	{
		
		fprintf(fp, "%s", msg);
		fclose(fp);

	}

}

/*
---------------------------------------------------------------------------
Funzione : Applicazione::Error
Input    : char *
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Applicazione::Error (char * stringa)
{

	Log(stringa);
	exit(-1);

}

/*
---------------------------------------------------------------------------
Funzione : Applicazione::User
Input    : int
         : char **
Output   : int
Commento : 
---------------------------------------------------------------------------
*/

int Applicazione::User (void)
{

	char
		c;

	if (kbhit())
	{

		if ((c = getch()) == 32)
			c = getch();
		else if (c == 27)
			return 1;

	}

	return 0;

}

/*
---------------------------------------------------------------------------
Funzione : Applicazione::Main
Input    : int
         : char **
Output   : int
Commento :
---------------------------------------------------------------------------
*/

int Applicazione::Main (int ac, char ** av)
{

	char
		arg [128] = "music32.dat";

	sprintf(Applicazione::ErrMsg, "\n%s\n%s\n", Applicazione::Logo, Applicazione::Versione);
	Applicazione::Debug(Applicazione::ErrMsg);

	if (ac == 2)
		strcpy(arg, av[1]);

	Parser::Parse_file(arg);
	Parser::Sinth.ElaboraOggetti();
	return 0;

}

/*
---------------------------------------------------------------------------
Funzione : main
Input    : int
         : char **
Output   : int
Commento :
---------------------------------------------------------------------------
*/

int main (int ac, char ** av)
{

	return Applicazione::Main(ac, av);

}
