
/*
---------------------------------------------------------------------------
ECN FreeSoft
---------------------------------------------------------------------------
Progetto : music32
Modulo   : parser.cpp
Inizio   : 29.07.2000
Fine     :
Versione : 1.0
Autore/i : Giorgio D.Plescan
Commento :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Switch
---------------------------------------------------------------------------
*/

//# define      DEBUG

/*
---------------------------------------------------------------------------
Include
---------------------------------------------------------------------------
*/

# include       <stdio.h>
# include       <math.h>
# include       <stdlib.h>
# include       <string.h>
# include       <io.h>
# include       <conio.h>
# include	<errno.h>

# include	"music32.h"
# include	"device.h"
# include	"parser.h"

/*
---------------------------------------------------------------------------
Funzioni locali
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Variabili globali
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Parser
---------------------------------------------------------------------------
*/

char
	* Parser::KeyNull = "???",
	* Parser::Token   = NULL,
	* Parser::Sep     = " ,\t\n",
	Parser::Objname [OBJ_NAME_LEN + 1];

KEYWORD
	Parser::Direttiva [] =
	{
		{"include", Parser::Parse_include},
		{"define",  Parser::Parse_define},
		{"declare", Parser::Parse_declare},
		{"connect", Parser::Parse_connect},
		{"assign",  Parser::Parse_assign},
		{Parser::KeyNull,   NULL}

	};

KEYWORD
	Parser::Oggetto [] =
	{
		{"som",   Parser::Parse_som},
		{"mol",   Parser::Parse_mol},
		{"mod",   Parser::Parse_mod},
		{"rum",   Parser::Parse_rum},
		{"ass",   Parser::Parse_ass},
		{"con",   Parser::Parse_con},
		{"inv",   Parser::Parse_inv},
		{"mem",   Parser::Parse_mem},
		{"com",   Parser::Parse_com},
		{"osc",   Parser::Parse_osc},
		{"out",   Parser::Parse_out},
		{Parser::KeyNull, NULL}

	};

Sintetizzatore
	Parser::Sinth;

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_oggetto
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_oggetto (void)
{

	static char
		* procname = "Parser::Parse_oggetto";
	int
		i;

	if (Sinth.CercaOggetti(Token) != NULL_INDEX)
	{

		sprintf(Applicazione::ErrMsg, "%s : NOME OGGETTO INASPETTATO |%s|\n", procname, Token);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	for (i = 0; ; i++)
	{

		if (strcmp(Token, Direttiva[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : DIRETTIVA INASPETTATA |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(KeyNull, Direttiva[i].Key) == 0)
		{

			break;

		}

	}

	for (i = 0; ; i++)
	{

		if (strcmp(KeyNull, Oggetto[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : TIPO OGGETTO SCONOSCIUTO |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(Token, Oggetto[i].Key) == 0)
		{

			Oggetto[i].Parse();
			break;

		}

	}

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_som
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_som (void)
{

	static char
		* procname = "Parser::Parse_som";
	int
		nin = 2;

	if ((Token = strtok(NULL, Sep)) != NULL)
	{

		nin = atoi(Token);

	}

	Sinth.InserisciOggetti((Dispositivo *)new Sommatore(nin), Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s\n", procname, Objname);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_mol
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_mol (void)
{

	static char
		* procname = "Parser::Parse_mol";
	int
		nin = 2;

	if ((Token = strtok(NULL, Sep)) != NULL)
	{

		nin = atoi(Token);

	}

	Sinth.InserisciOggetti((Dispositivo *)new Moltiplicatore(nin), Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s\n", procname, Objname);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_mod
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_mod (void)
{

	static char
		* procname = "Parser::Parse_mod";

	Sinth.InserisciOggetti((Dispositivo *)new Modulatore, Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s\n", procname, Objname);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_rum
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_rum (void)
{

	static char
		* procname = "Parser::Parse_rum";

	Sinth.InserisciOggetti((Dispositivo *)new Rumore, Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s\n", procname, Objname);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_ass
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_ass (void)
{

	static char
		* procname = "Parser::Parse_ass";

	Sinth.InserisciOggetti((Dispositivo *)new Assoluto, Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s\n", procname, Objname);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_con
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_con (void)
{

	static char
		* procname = "Parser::Parse_con";

	Sinth.InserisciOggetti((Dispositivo *)new Conduttore, Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s\n", procname, Objname);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_inv
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_inv (void)
{

	static char
		* procname = "Parser::Parse_inv";

	Sinth.InserisciOggetti((Dispositivo *)new Invertitore, Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s\n", procname, Objname);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_mem
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_mem (void)
{

	static char
		* procname = "Parser::Parse_mem";
	double
		val = 0.0;

	if ((Token = strtok(NULL, Sep)) != NULL)
	{

		val = atof(Token);

	}

	Sinth.InserisciOggetti((Dispositivo *)new Memoria(val), Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s - VAL=%lf\n", procname, Objname, val);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_com
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_com (void)
{

	static char
		* procname = "Parser::Parse_com";
			
	double
		so = 0.0;

	if ((Token = strtok(NULL, Sep)) != NULL)
	{

		so = atof(Token);

	}

	Sinth.InserisciOggetti((Dispositivo *)new Compressore(so), Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s - SGL=%lf\n", procname, Objname, so);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_osc
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_osc (void)
{

	static char
		* procname = "Parser::Parse_osc";
	int
		on = SENO;
	double
		fr = 0.0;

	if ((Token = strtok(NULL, Sep)) != NULL)
	{

		on = atoi(Token);

	}

	if ((Token = strtok(NULL, Sep)) != NULL)
	{

		fr = atof(Token);

	}

	Sinth.InserisciOggetti((Dispositivo *)new Oscillatore(on, fr), Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s - ON=%1d FR=%lf\n", procname, Objname, on, fr);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_out
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_out (void)
{

	static char
		* procname = "Parser::Parse_out";
	char
		nomef [FILE_BUFFER_LEN + 1];
	int
		piste = 1;

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA NOME FILE\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	strcpy(nomef, Token);

	if ((Token = strtok(NULL, Sep)) != NULL)
	{

		if ((Token[0] < '0') || (Token[0] > '9'))
		{
	
			sprintf(Applicazione::ErrMsg, "%s : PISTA NON VALIDA |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		piste = atoi(Token);

	}

	Sinth.InserisciOggetti((Dispositivo *)new Registratore(nomef, piste), Objname);

	sprintf(Applicazione::ErrMsg, "%s : CREATO %s - FILE=%s PISTE=%1d\n", procname, Objname, nomef, piste);
	Applicazione::Debug(Applicazione::ErrMsg);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_direttiva
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_direttiva (void)
{

	static char
		* procname = "Parser::Parse_direttiva";
	int
		i;

	if (Sinth.CercaOggetti(Token) != NULL_INDEX)
	{

		sprintf(Applicazione::ErrMsg, "%s : NOME OGGETTO INASPETTATO |%s|\n", procname, Token);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	for (i = 0; ; i++)
	{

		if (strcmp(Token, Oggetto[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : TIPO OGGETTO INASPETTATO |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(KeyNull, Oggetto[i].Key) == 0)
		{

			break;

		}

	}

	for (i = 0; ; i++)
	{

		if (strcmp(KeyNull, Direttiva[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : DIRETTIVA SCONOSCIUTA |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(Token, Direttiva[i].Key) == 0)
		{

			Direttiva[i].Parse();
			break;

		}

	}

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_define
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_define (void)
{

	static char
		* procname = "Parser::Parse_define";

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_include
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_include (void)
{

	static char
		* procname = "Parser::Parse_include";
	char
		nomef [FILE_NAME_LEN + 1];

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA NOME FILE\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	strcpy(nomef, Token);
	Parse_file(nomef);

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_declare
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_declare (void)
{

	static char
		* procname = "Parser::Parse_declare";
	int
		i;

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA NOME OGGETTO\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	for (i = 0; ; i++)
	{

		if (strcmp(Token, Direttiva[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : DIRETTIVA INASPETTATA |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(KeyNull, Direttiva[i].Key) == 0)
		{

			break;

		}

	}

	for (i = 0; ; i++)
	{

		if (strcmp(Token, Oggetto[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : TIPO OGGETTO INASPETTATO |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(KeyNull, Oggetto[i].Key) == 0)
		{

			break;

		}

	}

	if (Sinth.CercaOggetti(Token) != NULL_INDEX)
	{

		sprintf(Applicazione::ErrMsg, "%s : OGGETTO DUPLICATO |%s|\n", procname, Token);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	strcpy(Objname, Token);

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA TIPO OGGETTO\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	Parse_oggetto();

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_connect
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_connect (void)
{

	static char
		* procname = "Parser::Parse_connect";
	int
		i,
		src,
		cs,
		des,
		cd;

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA OGGETTO SORGENTE\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	for (i = 0; ; i++)
	{

		if (strcmp(Token, Direttiva[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : DIRETTIVA INASPETTATA |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(KeyNull, Direttiva[i].Key) == 0)
		{

			break;

		}

	}

	for (i = 0; ; i++)
	{

		if (strcmp(Token, Oggetto[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : TIPO OGGETTO INASPETTATO |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(KeyNull, Oggetto[i].Key) == 0)
		{

			break;

		}

	}

	if ((src = Sinth.CercaOggetti(Token)) == NULL_INDEX)
	{

		sprintf(Applicazione::ErrMsg, "%s : OGGETTO NON TROVATO |%s|\n", procname, Token);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA CANALE SORGENTE\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	if ((Token[0] < '0') || (Token[0] > '9'))
	{

		sprintf(Applicazione::ErrMsg, "%s : CANALE NON VALIDO |%s|\n", procname, Token);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	cs = atoi(Token);

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA OGGETTO DESTINAZIONE\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	for (i = 0; ; i++)
	{

		if (strcmp(Token, Direttiva[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : DIRETTIVA INASPETTATA |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(KeyNull, Direttiva[i].Key) == 0)
		{

			break;

		}

	}

	for (i = 0; ; i++)
	{

		if (strcmp(Token, Oggetto[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : TIPO OGGETTO INASPETTATO |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(KeyNull, Oggetto[i].Key) == 0)
		{

			break;

		}

	}

	if ((des = Sinth.CercaOggetti(Token)) == NULL_INDEX)
	{

		sprintf(Applicazione::ErrMsg, "%s : OGGETTO NON TROVATO |%s|\n", procname, Token);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA CANALE DESTINAZIONE\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	if ((Token[0] < '0') || (Token[0] > '9'))
	{

		sprintf(Applicazione::ErrMsg, "%s : CANALE NON VALIDO |%s|\n", procname, Token);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	cd = atoi(Token);

	if (Sinth.CollegaOggetti(src, cs, des, cd) == APP_ERROR)
	{

		sprintf(Applicazione::ErrMsg, "%s : ERRORE COLLEGAMENTO OGGETTI\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_assign
Input    : void
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_assign (void)
{

	static char
		* procname = "Parser::Parse_assign";
	int
		i,
		des,
		can;
	double
		val;

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA VALORE SORGENTE\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	val = atof(Token);

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA OGGETTO DESTINAZIONE\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	for (i = 0; ; i++)
	{

		if (strcmp(Token, Direttiva[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : DIRETTIVA INASPETTATA |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(KeyNull, Direttiva[i].Key) == 0)
		{

			break;

		}

	}

	for (i = 0; ; i++)
	{

		if (strcmp(Token, Oggetto[i].Key) == 0)
		{

			sprintf(Applicazione::ErrMsg, "%s : TIPO OGGETTO INASPETTATO |%s|\n", procname, Token);
			Applicazione::Error(Applicazione::ErrMsg);

		}

		if (strcmp(KeyNull, Oggetto[i].Key) == 0)
		{

			break;

		}

	}

	if ((des = Sinth.CercaOggetti(Token)) == NULL_INDEX)
	{

		sprintf(Applicazione::ErrMsg, "%s : OGGETTO NON TROVATO |%s|\n", procname, Token);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	if ((Token = strtok(NULL, Sep)) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : MANCA CANALE\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	if ((Token[0] < '0') || (Token[0] > '9'))
	{

		sprintf(Applicazione::ErrMsg, "%s : CANALE NON VALIDO |%s|\n", procname, Token);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	can = atoi(Token);

	if (Sinth.IngressoOggetti(val, des, can) == APP_ERROR)
	{

		sprintf(Applicazione::ErrMsg, "%s : ERRORE ASSEGNAMENTO VALORE INGRESSO\n", procname);
		Applicazione::Error(Applicazione::ErrMsg);

	}

}

/*
---------------------------------------------------------------------------
Funzione : Parser::Parse_file
Input    : char *
Output   : void
Commento :
---------------------------------------------------------------------------
*/

void Parser::Parse_file (char * nomef)
{

	static char
		* procname = "Parser::Parse_file";
	FILE
		* fp;
	char
		buf [FILE_BUFFER_LEN + 1];

	sprintf(Applicazione::ErrMsg, "%s : FILE=%s\n", procname, nomef);
	Applicazione::Debug(Applicazione::ErrMsg);

	if ((fp = fopen(nomef, "r")) == NULL)
	{

		sprintf(Applicazione::ErrMsg, "%s : fopen(%s) - error %1d\n", procname, nomef, errno);
		Applicazione::Error(Applicazione::ErrMsg);

	}

	while (fgets(buf, FILE_BUFFER_LEN, fp) != NULL)
	{

		buf[strlen(buf) - 1] = 32;

		sprintf(Applicazione::ErrMsg, "%s : |%s|\n", procname, buf);
		Applicazione::Debug(Applicazione::ErrMsg);

		if ((Token = strtok(buf, Sep)) == NULL) // Riga vuota
			continue;

		if (Token[0] == CHR_COMMENTO) // Commento
			continue;

		Parse_direttiva();

	}

	fclose(fp);

}
