
/*
---------------------------------------------------------------------------
ECN FreeSoft
---------------------------------------------------------------------------
Progetto : music32
Modulo   : parser.h
Inizio   : 29.07.2000
Fine     :
Versione : 1.0
Autore/i : Giorgio D.Plescan
Commento :
---------------------------------------------------------------------------
*/

/*
---------------------------------------------------------------------------
Define
---------------------------------------------------------------------------
*/

# define	FILE_NAME_LEN		32
# define	FILE_BUFFER_LEN		200
# define	OBJ_NAME_LEN		32

# define	CHR_COMMENTO		'#'

/*
---------------------------------------------------------------------------
Typedef
---------------------------------------------------------------------------
*/

typedef struct T_KEYWORD
{

	char
		* Key;

	void
		(* Parse) (void);
		 
} KEYWORD;

/*
---------------------------------------------------------------------------
Class
---------------------------------------------------------------------------
*/

class Parser
{

	private :

	public :

		static char
			* KeyNull,
			* Token,
			* Sep,
			Objname [OBJ_NAME_LEN + 1];

		static KEYWORD
			Direttiva[],
			Oggetto  [];

		static Sintetizzatore
			Sinth;

		static void Parse_oggetto   (void);
		static void Parse_som       (void);
		static void Parse_mol       (void);
		static void Parse_mod       (void);
		static void Parse_rum       (void);
		static void Parse_ass       (void);
		static void Parse_con       (void);
		static void Parse_inv       (void);
		static void Parse_mem       (void);
		static void Parse_com       (void);
		static void Parse_osc       (void);
		static void Parse_out       (void);

		static void Parse_direttiva (void);
		static void Parse_include   (void);
		static void Parse_define    (void);
		static void Parse_declare   (void);
		static void Parse_connect   (void);
		static void Parse_assign    (void);

		static void Parse_file      (char * nomef);

};
